#INCLUDE "diamp_pdm_ab.h"

DEFINE CLASS _DIAMP_PDM_AB AS _PDM_AB OF AB_Bases.fxp
 NAME            = "_DIAMP_PDM_AB"

 ID              = 6			&& ID of Plug-in
 TYPE            = "DIAMP"		&& Typ of plug-in (group)


 gcClass_Setting = "_diamp_pdm_ab_par"

 DIMENSION gaParaLink[1,3]		&& Array to store parameter names and links to parameters for use in other sections.

 gcRetVal        = ''			&& Storage for return value part between Parse_Sect und Generate_HTML
 gcReturnType    = ''			&& Storage for returntype part between Parse_Sect und Generate_HTML
 DIMENSION gaParams[1,8]		&& Storage for params part between Parse_Sect und Generate_HTML
 gnParams        = 0			&& Storage for count of params between Parse_Sect und Generate_HTML

 gcRetAnchor  	 = ''			&& Anchor for ReturnValue
 gcRetLink       = ''			&& Link to for ReturnValue

 PROCEDURE GetCaption && Return Caption of Plug-in
  RETURN THIS.GetString(PI_Caption)
 ENDPROC &&GetCaption

 PROCEDURE GetDescription && Return Description of Plug-in
  RETURN THIS.GetString(PI_Description)
 ENDPROC &&GetDescription

 PROCEDURE Parse_Sect  &&Parse for sections
  PARAMETERS;
   tcSource,;
   tcSource_C

  LOCAL ARRAY;
   laSections2(1,4),;
   laSections3(1,4)

  LOCAL;
   lcOuterSection,;
   lcTemp1,;
   lcTemp2,;
   lnLoop1,;
   lnLoop2,;
   llFirstLoop,;
   loMatchPDM

  STORE 0  TO;
   THIS.gnParams

  STORE "" TO;
   THIS.gcRetVal,;
   THIS.gcReturnType

  LOCAL;
   loRegExp

*store old settings
  loRegExp = THIS.goRegExp
  loRegExp.STORE()

  loRegExp.IgnoreCase = .T.
  loRegExp.GLOBAL     = .T.
  loRegExp.MultiLine  = .T.

*Return Value
*in einem anderen PDM Sector wurde RetVal schon genutzt, also jetzt kein Typ mehr, nur TextZeilen
*es wird nur RetVal der ersten Section ausgewertet.
  llFirstLoop = EMPTY(THIS.gcRetVal+THIS.gcReturnType)
*Get all Return Value
*i.e. anything in THIS.goSettings.gcRetVal Tags, Default: <RetVal>
  FOR lnLoop1 = 1 TO THIS.Get_Tag(tcSource,THIS.goSettings.gcRetVal,@laSections2,.T.)
   lcOuterSection = laSections2(lnLoop1,1)
   DO CASE
    CASE llFirstLoop AND laSections2(lnLoop1,2)='tag'
*Get Start Tag
     loRegExp.PATTERN = "<\s*("+THIS.goSettings.gcRetVal+")(\s[^>]*)?>"
     loMatchPDM        = loRegExp.Execute(lcOuterSection)
     lcTemp1           = loMatchPDM.ITEM(0).VALUE
     THIS.gcReturnType = THIS.Get_TagValue(lcTemp1,THIS.goSettings.gcParamsType)
     llFirstLoop  = .F.
    CASE llFirstLoop
*prefix type does not declare Type
     llFirstLoop = .F.
   ENDCASE
   IF laSections2(lnLoop1,2)='tag' THEN
*Strip tags
    loRegExp.PATTERN = "<\s*("+THIS.goSettings.gcRetVal+")(\s[^>]*)?>"
    lcOuterSection   = THIS.goRegExp.REPLACE(lcOuterSection,'')
    loRegExp.PATTERN = "<\s*\/("+THIS.goSettings.gcRetVal+")\s*>"
    lcOuterSection   = THIS.goRegExp.REPLACE(lcOuterSection,'')
   ENDIF &&laSections2(lnLoop1,2)='tag'
   THIS.gcRetVal = THIS.gcRetVal+CRLF+;
    lcOuterSection
  ENDFOR &&loLoop1

*Parameter(s) Value
*Get all Parameter Value
*i.e. anything in THIS.goSettings.gcParams Tags, Default: <Params>
  FOR lnLoop1 = 1 TO THIS.Get_Tag(tcSource,THIS.goSettings.gcParams,@laSections2,.T.)
   lcOuterSection = laSections2(lnLoop1,1)
   DO CASE
    CASE laSections2(lnLoop1,2)='tag'
*tag type, alle within the section and the first tag
*Get Start Tag
     loRegExp.PATTERN = "<\s*("+THIS.goSettings.gcParams+")(\s[^>]*)?>"
     loMatchPDM       = loRegExp.Execute(lcOuterSection)
     lcTemp1          = loMatchPDM.ITEM(0).VALUE
*Parameters Name; Attribut: Name
     lcTemp2 = THIS.Get_TagValue(lcTemp1,THIS.goSettings.gcParamsName)
     IF EMPTY(lcTemp2) THEN
*without name will be ignored
      LOOP
     ENDIF &&EMPTY(lcTemp2)
     THIS.gnParams = THIS.gnParams+1
     DIMENSION;
      THIS.gaParams(THIS.gnParams,8)
     STORE "" TO;
      THIS.gaParams(THIS.gnParams,5),;
      THIS.gaParams(THIS.gnParams,6)
     STORE 0 TO;
      THIS.gaParams(THIS.gnParams,7),;
      THIS.gaParams(THIS.gnParams,8)

     THIS.gaParams(THIS.gnParams,1) = lcTemp2
*Parameters ByReference; Attribut: ByRef
     THIS.gaParams(THIS.gnParams,2) = THIS.Get_TagValue(lcTemp1,THIS.goSettings.gcParamsReference)
*Parameters Direction; Attribut: Dir
     THIS.gaParams(THIS.gnParams,3) = THIS.Get_TagValue(lcTemp1,THIS.goSettings.gcParamsDirection)
     IF EMPTY(THIS.gaParams(THIS.gnParams,3)) THEN
      THIS.gaParams(THIS.gnParams,3) = 'Input'
     ENDIF &&empty(this.gaParams(this.gnParams,3))
*Parameters Type; Attribut: Type
     THIS.gaParams(THIS.gnParams,4) = THIS.Get_TagValue(lcTemp1,THIS.goSettings.gcParamsType)
*Parameters Short description; Tag: <SHORT>
     FOR lnLoop2 = 1 TO THIS.Get_Tag(lcOuterSection,THIS.goSettings.gcParamsShortDesc,@laSections3,.F.)
      THIS.gaParams(THIS.gnParams,5) = THIS.gaParams(THIS.gnParams,5)+CRLF+;
       laSections3(lnLoop2,1)
     ENDFOR &&lnLoop2
*Parameters Long description; Tag: <DETAIL>
     FOR lnLoop2 = 1 TO THIS.Get_Tag(lcOuterSection,THIS.goSettings.gcParamsLongDesc,@laSections3,.F.)
      THIS.gaParams(THIS.gnParams,6) = THIS.gaParams(THIS.gnParams,6)+CRLF+;
       laSections3(lnLoop2,1)
     ENDFOR &&lnLoop2
*Parameters Opening brackets for optional Parameters; Attribut: InB
     THIS.gaParams(THIS.gnParams,7) = THIS.Get_TagValue(lcTemp1,THIS.goSettings.gcParamsOptionalIn)
*Parameters Closing brackets for optional Parameters; Attribut: OutB
     THIS.gaParams(THIS.gnParams,8) = THIS.Get_TagValue(lcTemp1,THIS.goSettings.gcParamsOptionalOut)

*Reformat special elements
     THIS.gaParams(THIS.gnParams,2) = IIF(THIS.gaParams(THIS.gnParams,2)=='1',THIS.goSettings.gcParamsReference,'')
     THIS.gaParams(THIS.gnParams,7) = MIN(MAX(VAL(THIS.gaParams(THIS.gnParams,7)),0),26)
     THIS.gaParams(THIS.gnParams,8) = MIN(MAX(VAL(THIS.gaParams(THIS.gnParams,8)),0),26)
    OTHERWISE
*prefix type, in the first row Name Byref Dir Type "short description"
     loRegExp.PATTERN = "\b\S+\b"
     loMatchPDM       = loRegExp.Execute(lcOuterSection)
*Parameters Name, first word
     IF loMatchPDM.COUNT>0 THEN
      THIS.gnParams = THIS.gnParams+1
      DIMENSION;
       THIS.gaParams(THIS.gnParams,8)
      STORE "" TO;
       THIS.gaParams(THIS.gnParams,5),;
       THIS.gaParams(THIS.gnParams,6)
      STORE 0 TO;
       THIS.gaParams(THIS.gnParams,7),;
       THIS.gaParams(THIS.gnParams,8)

      THIS.gaParams(THIS.gnParams,1) = ALLTRIM(loMatchPDM.ITEM(0).VALUE)
*Parameters ByReference; second word
      IF loMatchPDM.COUNT>1 THEN
       THIS.gaParams(THIS.gnParams,2) = ALLTRIM(loMatchPDM.ITEM(1).VALUE)
*Parameters Direction; third word
       IF loMatchPDM.COUNT>2 THEN
        THIS.gaParams(THIS.gnParams,3) = ALLTRIM(loMatchPDM.ITEM(2).VALUE)
*Parameters Type; Attribut: 4.th word
        IF loMatchPDM.COUNT>3 THEN
         THIS.gaParams(THIS.gnParams,4) = ALLTRIM(loMatchPDM.ITEM(3).VALUE)
*Parameters Short description; rest of line
         IF LEN(lcOuterSection)>loMatchPDM.ITEM(3).FirstIndex+1+loMatchPDM.ITEM(3).LENGTH THEN
          THIS.gaParams(THIS.gnParams,5) = CRLF+SUBSTR(lcOuterSection,loMatchPDM.ITEM(3).FirstIndex+1+loMatchPDM.ITEM(3).LENGTH)
         ENDIF &&LEN(lcOuterSection ...
        ENDIF &&loMatchPDM.count>3
       ENDIF &&loMatchPDM.count>2
      ENDIF &&loMatchPDM.count>1
     ENDIF &&loMatchPDM.count>0
*Parameters Long description;
*following lines starting with PARAMS_Name
*Get Part of PDM Section after parameters line
     lcTemp1 = SUBSTR(tcSource,laSections2(lnLoop1,3)+laSections2(lnLoop1,4))
*Get following lines
     FOR lnLoop2 = 1 TO THIS.Get_Tag(lcTemp1,'',@laSections3,.F.,THIS.goSettings.gcParams+'_'+THIS.gaParams(THIS.gnParams,1))
      THIS.gaParams(THIS.gnParams,6) = THIS.gaParams(THIS.gnParams,6)+CRLF+;
       laSections3(lnLoop2,1)
     ENDFOR &&lnLoop2
   ENDCASE
  ENDFOR &&lnLoop1
  THIS.gcRetVal    = SUBSTR(THIS.gcRetVal,3)
  FOR lnLoop1 = 1 TO THIS.gnParams
   THIS.gaParams(lnLoop1,5) = SUBSTR(THIS.gaParams(lnLoop1,5),3)
   THIS.gaParams(lnLoop1,6) = SUBSTR(THIS.gaParams(lnLoop1,6),3)
  ENDFOR &&lnLoop1

*Get all remaining information
*that is - all what is not a prefixed line
*          and outside a tag
*Remove all Return Value
*i.e. anything in THIS.goSettings.gcRetVal Tags, Default: <RetVal>
  tcSource =  THIS.Remove_Tag(tcSource,THIS.goSettings.gcRetVal)
*Remove all Parameter Value
*i.e. anything in THIS.goSettings.gcParams Tags, Default: <Params>
  tcSource =  THIS.Remove_Tag(tcSource,THIS.goSettings.gcParams)
*Remove all Parameter Long descriptions, prefix verison
  tcSource =  THIS.Remove_Tag(tcSource,,THIS.goSettings.gcParams+'_\S*')

*restore old settings
  loRegExp.RESTORE()

*Remainig will be parsed in parent
  RETURN DODEFAULT(tcSource,tcSource_C)
 ENDPROC &&Parse_Sect


 PROCEDURE Get_PDMFromSource &&Get PEM section from source code to deal with
  PARAMETERS;
   toRAM

  RETURN toRAM.XXDESC
 ENDPROC &&Get_PDMFromSource

 PROCEDURE Generate_HTML  &&Generates HTML Output for Render by previously paresd information
  LOCAL;
   lcHTML

*!*	  IF TYPE("pld")='U' THEN
*!*	   DEBUG
*!*	   SUSPEND
*!*	  ENDIF &&TYPE("pld")='U'

  lcHTML = ''
*Parameters. We parse this first to get targets for ParaLinks
  lcHTML = lcHTML+THIS.Sect_Parameters()

*Description. We parsing this after Params to resolve ParaLinks
  IF LEN(STRTRAN(THIS.gcDescr,CRLF,""))>0 THEN
   lcHTML = THIS.Sect_Description()+lcHTML
  ENDIF &&LEN(STRTRAN(this.gcDescr,CRLF ...

*Return Value
  IF LEN(STRTRAN(THIS.gcRetVal+THIS.gcReturnType,CRLF,""))>0 THEN
   lcHTML = lcHTML+THIS.Sect_Return()
  ENDIF &&LEN(STRTRAN(this.gcRetVal,CRLF ...

*Remarks
  IF LEN(STRTRAN(THIS.gcRemark,CRLF,""))>0 THEN
   lcHTML = lcHTML+THIS.Sect_Remark()
  ENDIF &&LEN(STRTRAN(THIS.gcRemark,CRLF ...

*Example
  IF LEN(STRTRAN(THIS.gcExample,CRLF,""))>0 THEN
   lcHTML = lcHTML+THIS.Sect_Example()
  ENDIF &&LEN(STRTRAN(this.gcExample,CRLF ...

*Others
  IF LEN(STRTRAN(THIS.gcOther,CRLF,""))>0 THEN
   lcHTML = lcHTML+THIS.Sect_Others()
  ENDIF &&LEN(STRTRAN(this.gcOther,CRLF ...

*see also
  IF THIS.gnSeeAlso+THIS.gnToSeeAlso>0 THEN
   lcHTML = lcHTML+THIS.Sect_SeeAlso()
  ENDIF &&THIS.gnSeeAlso+THIS.gnToSeeAlso>0

*Changes
  IF THIS.gnChange>0 THEN
   lcHTML = lcHTML+THIS.Sect_Change()
  ENDIF &&THIS.gnChange>0

*Copyright
  IF LEN(STRTRAN(THIS.gcCopyRight,CRLF,""))>0 THEN
   lcHTML = lcHTML+THIS.Sect_CopyRight()
  ENDIF &&LEN(STRTRAN(THIS.gcCopyRight,CRLF ...

*Footer
  THIS.Sect_Footer()

  RETURN lcHTML
 ENDPROC &&Generate_HTML

 PROCEDURE Sect_Parameters &&create HTML section parameters
  LOCAL;
   lcPEM,;
   lcSyntax,;
   lcParams,;
   lcAncor,;
   lcSyntax_Para1,;
   lcSyntax_Para2,;
   lcSyntax_ParaF,;
   lcRetVal,;
   lnLoop1,;
   lnBrackets_Act,;
   lnBrackets_Sto,;
   lnLenght_ParaS,;
   lnLenght_LineS,;
   llTemp1

  DIMENSION;
   THIS.gaParaLink(1,3)
  THIS.gaParaLink = ''

  DO CASE
   CASE UPPER(THIS.gcActivePEM)="MAIN PROGRAM"
*see if the Procedure we do is the "main" of a prg
    lcPEM = JUSTSTEM(THIS.gcActiveFile)
   CASE EMPTY(THIS.gcActiveClass)
*prg based procedure
    lcPEM = THIS.gcActivePEM
   OTHERWISE
*method
    lcPEM = THIS.GetHTMLString(PI_HTML_Object)+THIS.gcActivePEM
  ENDCASE

*check if we have a return, if then create target anchor
  IF EMPTY(THIS.gcRetVal+THIS.gcReturnType) THEN
   lcRetVal         = ''
   THIS.gcRetAnchor = ''
   THIS.gcRetLink   = ''
  ELSE &&EMPTY(THIS.gcRetVal+THIS.gcReturnType)
   THIS.gcRetAnchor = SYS(2015)
   THIS.gcRetLink   = [<a class="]+THIS.goSettings.gcCSS_ParaLink+[" href="#]+THIS.gcRetAnchor+[">]+THIS.GetHTMLString(PI_HTML_Return)+[</a>]
   lcRetVal         = [<a href="#]+THIS.gcRetAnchor+[">]+THIS.GetHTMLString(PI_HTML_RetVar)+[</a>]
  ENDIF &&EMPTY(THIS.gcRetVal+THIS.gcReturnType)

*Parameters
  DO CASE
   CASE EMPTY(THIS.gcActivePEM)
    lcParams = ""
    lcSyntax = ""
   CASE THIS.gnParams>0
*new style, SF 08.02.2004
*We do a "Usage" Line like in VFP'S CHM files and a separate list of parameters
*the usage line is a one line table
*Init LinkArray
    DIMENSION;
     THIS.gaParaLink(THIS.gnParams,3)
    THIS.gaParaLink = ''

    lcSyntax = ;
     [ <div class="]+THIS.goSettings.gcCSS_Syntax+["><!-- Syntax Begin -->]+CRLF+;
     [  <div class="]+THIS.goSettings.gcCSS_Syntax_Color+[">]+CRLF
    IF !EMPTY(lcRetVal) THEN
     lcSyntax = lcSyntax+;
      [   <div class="]+THIS.goSettings.gcCSS_Syntax_RetVal+[">]+;
      lcRetVal+[&nbsp;</div>]+;
      [   <div class="]+THIS.goSettings.gcCSS_Syntax_RetValSign+[">=</div>]
    ENDIF &&!EMPTY(lcRetVal)
    lcSyntax = lcSyntax+;
     [   <div class="]+THIS.goSettings.gcCSS_Syntax_Method+[">]+CRLF+;
     [    ]+lcPEM+CRLF+;
     [   </div>]+CRLF+;
     [   <div class="]+THIS.goSettings.gcCSS_Syntax_Para+[">]+CRLF+;
     [    (]

    lcParams = ;
     [ <div class="]+THIS.goSettings.gcCSS_Para+["><!-- Parameters Begin -->]+CRLF+;
     [  <span class="]+THIS.goSettings.gcCSS_Para_Head+[">]+CRLF+;
     [   ]+THIS.GetHTMLString(PI_HTML_Params)+CRLF+;
     [  </span>]+CRLF+;
     [  <dl class="]+THIS.goSettings.gcCSS_Para_List+[">]+CRLF

*initial values
    lnBrackets_Act = 0				&&Brackets opening on this para
    lnBrackets_Sto = 0				&&Open brackets storage
    lcSyntax_Para1 = []				&&parameters
    lcSyntax_Para2 = []		        &&only to format htmltext
    lcSyntax_ParaF = [     ]		&&only to format htmltext
    lnLenght_ParaS = 0 				&&Chars per Parameter
    lnLenght_LineS = 0 				&&Chars per line
    FOR lnLoop1 = 1 TO THIS.gnParams
*SF 07.02.2004
*opening brackets
     lnBrackets_Act = THIS.gaParams(lnLoop1,7)
     IF !EMPTY(lnBrackets_Act) THEN
      lcSyntax_Para1 = lcSyntax_Para1+;
       REPLICATE('[',lnBrackets_Act)
      lnBrackets_Sto = lnBrackets_Sto+lnBrackets_Act
      lnLenght_LineS = lnLenght_LineS+lnBrackets_Act+1
     ENDIF &&!EMPTY(THIS.gaParams(lnLoop1,7))
* Comma after first parameter
     IF lnLoop1>1 THEN
      lcSyntax_Para1 = lcSyntax_Para1+[<wbr />,]
      lnLenght_LineS = lnLenght_LineS+2 &&Chars per line
     ENDIF &&lnLoop1>1
*ByRef
     IF THIS.gaParams(lnLoop1,2)==THIS.goSettings.gcParamsReference THEN
      lcSyntax_Para1 = lcSyntax_Para1+;
       [@]
      lnLenght_LineS = lnLenght_LineS+1
     ENDIF &&THIS.gaParams(lnLoop1 ...
*Parameter
*old Version of anchor could be to long
*we can do the following here, because we never crosslink int
     lcAncor = SYS(2015)
*Store Link
     THIS.gaParaLink(lnLoop1,1) = ;
      [<a class="]+THIS.goSettings.gcCSS_ParaLink+[" href="#]+lcAncor+[">]+;
      THIS.gaParams(lnLoop1,1)+[</a>]
     THIS.gaParaLink(lnLoop1,2) =lcAncor
*Uses A Types of CSS Class DIV.diamp_pdm_md_syntax
     lcSyntax_Para1 = lcSyntax_Para1+;
      [<a href="#]+lcAncor+[">]+THIS.gaParams(lnLoop1,1)+[</a>]
     lnLenght_LineS = lnLenght_LineS+LEN(THIS.gaParams(lnLoop1,1))
*closing brackets
*do not close more Brackets then opend before, close all on last parameter
     lnBrackets_Act = MAX(MIN(THIS.gaParams(lnLoop1,8),lnBrackets_Sto),IIF(lnLoop1=THIS.gnParams,lnBrackets_Sto,0))
     IF !EMPTY(lnBrackets_Act) THEN
      lcSyntax_Para1 = lcSyntax_Para1+;
       REPLICATE(']',lnBrackets_Act)
      lnBrackets_Sto = lnBrackets_Sto-lnBrackets_Act
      lnLenght_LineS = lnLenght_LineS+lnBrackets_Act
     ENDIF &&!EMPTY(THIS.gaParams(lnLoop1,7))
*store status of optional for second loop
     THIS.gaParaLink(lnLoop1,3) = !EMPTY(THIS.gaParams(lnLoop1,7));
      OR !EMPTY(THIS.gaParams(lnLoop1,8));
      OR (lnLoop1=THIS.gnParams AND !EMPTY(lnBrackets_Sto))
*if the line exeeds 160 chars do a new line,
* a line may exeed 160 chars if line without closing brackets and closing ')'
     IF lnLenght_ParaS+lnLenght_LineS>160 THEN
      lcSyntax  = ;
       lcSyntax+lcSyntax_Para2+CRLF+;
       lcSyntax_ParaF	&&+[<br /><!-- Linebreak in Syntax-->]
      lnLenght_ParaS = lnLenght_LineS
      lnLenght_LineS = 0
      lcSyntax_Para2 = lcSyntax_Para1
     ELSE &&lnLenght_ParaS+lnLenght_LineS>160
      lnLenght_ParaS = lnLenght_ParaS+lnLenght_LineS
      lcSyntax_Para2 = lcSyntax_Para2+lcSyntax_Para1
     ENDIF &&lnLenght_ParaS+lnLenght_LineS>160
     lcSyntax_Para1 = CRLF+lcSyntax_ParaF
    ENDFOR &&lnLoop1

*Second Part, we list all the Information
    FOR lnLoop1 = 1 TO THIS.gnParams
*First name and short description
     llTemp1       = THIS.glXHTML
     THIS.glXHTML  = .T.
     lcParams      = lcParams+;
      [   <dt class="]+THIS.goSettings.gcCSS_Para_List_dt+[">]+CRLF+;
      [    <a class="]+THIS.goSettings.gcCSS_Para_dd_Name+[" id="]+THIS.gaParaLink(lnLoop1,2)+;
      [" name="]+THIS.gaParaLink(lnLoop1,2)+[">]+CRLF
     IF THIS.goSettings.glIsVersion_1_2 THEN
*VERSION 1.2
      lcParams      = lcParams+;
       [     ]+THIS.goPDM.Expr2XHTML(THIS.gaParams(lnLoop1,1),2)+CRLF
     ELSE &&THIS.goSettings.glIsVersion_1_2
*VERSION 1.1.2
      lcParams      = lcParams+;
       [     ]+THIS.goPDM.Expr2XHTML(THIS.gaParams(lnLoop1,1))+CRLF
     ENDIF &&THIS.goSettings.glIsVersion_1_2
     lcParams      = lcParams+;
      [    </a>]+CRLF+;
      [   </dt>]+CRLF+;
      [   <dd class="]+THIS.goSettings.gcCSS_Para_List_dd+[">]+CRLF+;
      [    <span class="]+THIS.goSettings.gcCSS_Para_dd_short+[">]+CRLF+;
      [     ]+THIS.ParseText(THIS.gaParams(lnLoop1,5))+CRLF+;
      [    </span>]+CRLF
     THIS.glXHTML  = llTemp1
*Second Table with Type etc
*only if we have one of those in tag or last para has open brackets
*Uses Subclasses of CSS class diamp_pdm_ab_params
     IF !EMPTY(;
       THIS.gaParams(lnLoop1,2)+;
       THIS.gaParams(lnLoop1,3)+;
       THIS.gaParams(lnLoop1,4));
       OR !EMPTY(THIS.gaParams(lnLoop1,7));
       OR !EMPTY(THIS.gaParams(lnLoop1,8));
       OR (lnLoop1=THIS.gnParams AND !EMPTY(lnBrackets_Sto)) THEN
      lcParams = lcParams+;
       [    <table class="]+THIS.goSettings.gcCSS_Para_dd_TInfo+[">]+CRLF+;
       [     <colgroup>]+CRLF+;
       [      <col class="]+THIS.goSettings.gcCSS_Para_dd_TIS_ColInfo+[" />]+CRLF+;
       [      <col class="]+THIS.goSettings.gcCSS_Para_dd_TIS_ColDesc+[" />]+CRLF+;
       [     </colgroup>]+CRLF+;
       [     <tbody>]+CRLF
*Type
      IF !EMPTY(THIS.gaParams(lnLoop1,4)) THEN
       lcParams = lcParams+;
        [      <tr>]+CRLF+;
        [       <td class="]+THIS.goSettings.gcCSS_Para_dd_TIS_CellInfo+[">]+;
        THIS.GetHTMLString(PI_HTML_Type)+[</td>]+CRLF+;
        [       <td class="]+THIS.goSettings.gcCSS_Para_dd_TIS_CellDesc+[">]+;
        THIS.gaParams(lnLoop1,4)+[</td>]+CRLF+;
        [      </tr>]+CRLF
      ENDIF &&!EMPTY(THIS.gaParams(lnLoop1,4))
*By Refernce
      IF THIS.gaParams(lnLoop1,2)==THIS.goSettings.gcParamsReference THEN
       lcParams = lcParams+;
        [      <tr>]+CRLF+;
        [       <td class="]+THIS.goSettings.gcCSS_Para_dd_TIS_CellInfo+[">]+;
        THIS.GetHTMLString(PI_HTML_ByRef)+[</td>]+CRLF+;
        [       <td class="]+THIS.goSettings.gcCSS_Para_dd_TIS_CellDesc+[">&nbsp;</td>]+CRLF+;
        [      </tr>]+CRLF
      ENDIF && &&THIS.gaParams(lnLoop1 ...
*Direction
      IF !EMPTY(THIS.gaParams(lnLoop1,3)) THEN
       lcParams = lcParams+;
        [      <tr>]+CRLF+;
        [       <td class="]+THIS.goSettings.gcCSS_Para_dd_TIS_CellInfo+[">]+;
        THIS.GetHTMLString(PI_HTML_Direction)+[</td>]+CRLF+;
        [       <td class="]+THIS.goSettings.gcCSS_Para_dd_TIS_CellDesc+[">]+;
        THIS.gaParams(lnLoop1,3)+[</td>]+CRLF+;
        [      </tr>]+CRLF
      ENDIF &&!EMPTY(THIS.gaParams(lnLoop1,3))
*Optional
      IF   !EMPTY(THIS.gaParams(lnLoop1,7));
        OR !EMPTY(THIS.gaParams(lnLoop1,8));
        OR (lnLoop1=THIS.gnParams AND !EMPTY(lnBrackets_Sto)) THEN
       lcParams = lcParams+;
        [      <tr>]+CRLF+;
        [       <td class="]+THIS.goSettings.gcCSS_Para_dd_TIS_CellInfo+[">]+;
        THIS.GetHTMLString(PI_HTML_Optional)+[</td>]+CRLF+;
        [      <td class="]+THIS.goSettings.gcCSS_Para_dd_TIS_CellDesc+[">&nbsp;</td>]+CRLF+;
        [      </tr>]+CRLF
      ENDIF &&!EMPTY(THIS.gaParams(lnLoop1,7))        ...
      lcParams = lcParams+;
       [     </tbody>]+CRLF+;
       [    </table>]+CRLF
     ENDIF &&!EMPTY(      THIS.gaParams(lnLoop1 ...
*Detail
     IF !EMPTY(THIS.gaParams(lnLoop1,6)) THEN
      lcParams = lcParams+;
       [    <span class="]+THIS.goSettings.gcCSS_Para_dd_Detail+[">]+CRLF+;
       THIS.ParseText(THIS.gaParams(lnLoop1,6))+CRLF+;
       [    </span>]+CRLF
     ENDIF &&!EMPTY(THIS.gaParams(lnLoop1,6))
     lcParams = lcParams+;
      [   </dd>]+CRLF

    ENDFOR &&lnLoop1
    lcParams = lcParams+;
     [  </dl>]+CRLF+;
     [ </div><!-- Parameters End -->]+CRLF+CRLF

    lcSyntax = lcSyntax+;
     lcSyntax_Para2+[)]+CRLF+;
     [   </div>]+CRLF+;
     [   <div style="clear: both"></div>]+CRLF+;
     [  </div><!-- Colour End -->]+CRLF+;
     [ </div><!-- Syntax End -->]+CRLF+CRLF
   OTHERWISE
    lcParams = ""
    lcSyntax = ;
     [ <div class="]+THIS.goSettings.gcCSS_Syntax+["><!-- Syntax Begin -->]+CRLF+;
     [  <div class="]+THIS.goSettings.gcCSS_Syntax_Color+[">]+CRLF
    IF !EMPTY(lcRetVal) THEN
     lcSyntax = lcSyntax+;
      [   <div class="]+THIS.goSettings.gcCSS_Syntax_RetVal+[">]+;
      lcRetVal+[&nbsp;</div>]+;
      [   <div class="]+THIS.goSettings.gcCSS_Syntax_RetValSign+[">=</div>]
    ENDIF &&!EMPTY(lcRetVal)
    lcSyntax = lcSyntax+;
     [   <div class="]+THIS.goSettings.gcCSS_Syntax_Method+[">]+CRLF+;
     [    ]+lcPEM+CRLF+;
     [   </div>]+CRLF+;
     [   <div class="]+THIS.goSettings.gcCSS_Syntax_Para+[">]+CRLF+;
     [    ()]+CRLF+;
     [   </div>]+CRLF+;
     [  </div><!-- Colour End -->]+CRLF+;
     [ </div><!-- Syntax End -->]+CRLF+CRLF
  ENDCASE

  RETURN lcSyntax+lcParams
 ENDPROC &&Sect_Parameters

 PROCEDURE Sect_Return		&&create HTML section Return Value
  LOCAL;
   lcReturn

  lcReturn = ;
   [ <div class="]+THIS.goSettings.gcCSS_Return+["><!-- Returns Begin -->]+CRLF+;
   [  <div>]+CRLF+;
   [   <span class="]+THIS.goSettings.gcCSS_Return_Head+[">]+CRLF+;
   [    <a id="]+THIS.gcRetAnchor+[" name="]+THIS.gcRetAnchor+[">]+CRLF+;
   [     ]+THIS.GetHTMLString(PI_HTML_Return)+CRLF+;
   [    </a>]+CRLF+;
   [   </span>]
  IF !EMPTY(THIS.gcReturnType) THEN
   lcReturn = lcReturn+;
    [ <span class="]+THIS.goSettings.gcCSS_Return_Type+[">]+;
    THIS.gcReturnType+;
    [</span>]
  ENDIF &&!EMPTY(THIS.gcReturnType)
  lcReturn = lcReturn+CRLF+;
   [  </div>]+CRLF+;
   [  <div class="]+THIS.goSettings.gcCSS_Return_Body+[">]+CRLF+;
   THIS.ParseText(THIS.gcRetVal)+CRLF+;
   [  </div>]+CRLF+;
   [ </div><!-- Returns End -->]+CRLF+CRLF
  RETURN lcReturn
 ENDPROC &&Sect_Return

 PROCEDURE ParseText_EX &&Parse out extra parts tags that will not be covered by this method specific to plug in
  PARAMETERS;
   tcText,;
   tcTag,;
   tcOpenTag,;
   tcCloseTag

*this method will handle following tags:
*ParaLink			<pdmpara num="" />				link to a parameter/return value of the respective method
  LOCAL;
   lcReturn,;
   lnTemp1,;
   llTemp1

  DO CASE
   CASE THIS.goSettings.gcParaLink==tcTag
*link to parameter / return value
    lnTemp1 = VAL(THIS.Get_TagValue(tcOpenTag,THIS.goSettings.gcParaLinkNum,@llTemp1))
    DO CASE
     CASE !llTemp1
      lcReturn = THIS.GetErrorText(tcOpenTag,'Wrong parameter link')
*no id
     CASE EMPTY(lnTemp1) AND EMPTY(THIS.gcRetLink)
*points to retval, but ni retval declared
      lcReturn = THIS.GetErrorText(tcOpenTag,'Wrong return link')
     CASE EMPTY(lnTemp1)
*Return value
      lcReturn = THIS.gcRetLink
     CASE !BETWEEN(lnTemp1,1,ALEN(THIS.gaParaLink,1));
       OR EMPTY(THIS.gaParaLink(lnTemp1,1))
*no parameter named, not in array or row is empty
      lcReturn = THIS.GetErrorText(tcOpenTag,'Wrong parameter link')
     OTHERWISE
      lcReturn = THIS.gaParaLink(lnTemp1,1)
    ENDCASE
*/link to parameter / return value
   OTHERWISE
*this is the default method, but why call an extra method
    lcReturn = tcOpenTag+THIS.ParseText(tcText)+tcCloseTag
  ENDCASE
  RETURN lcReturn
 ENDPROC &&ParseText_EX


 PROCEDURE OpenSources
  PARAMETERS;
   loSetting

  DODEFAULT(loSetting)
 ENDPROC &&OpenSources
ENDDEFINE &&_DIAMP_PDM_AB

****************************************************************
DEFINE CLASS _diamp_pdm_ab_par AS _pdm_ab_par OF AB_Bases.fxp && Settings for plug-in
 NAME                    = [_diamp_pdm_ab_par]

*files
 gcCSS                   = [diamp_pdm_ab.css]				&& Relative to plug in

*tags that will create a group and their attributes
*newly defined part
 gcParams                = [params]						&& Parameter of a method
 gcParamsName            = [name]						&& Attribute of params tag Name of Parameter One Word
 gcParamsType            = [type]						&& Attribute of params and retval tag Type of Parameter One Word
 gcParamsReference       = [byref]						&& Attribute of params tag 1 results in @ as prefix to name
 gcParamsDirection       = [dir]						&& Direction of information One Word
 gcParamsOptionalIn      = [inb]						&& Attribute of params tag positive Number of openning brackets indicating optional para placed infront,
 gcParamsOptionalOut     = [outb]						&& Attribute of params tag positive Number of closing brackets indicating optional para placed after Name
 gcParamsShortDesc       = [short]						&& tag of params tag indicating short description
 gcParamsLongDesc        = [detail]						&& tag of params tag indicating long description
 gcRetVal                = [retval]						&& return value

 gcParaLink              = [pdmpara]					&& Link to parameter of the same method
 gcParaLinkNum           = [num]						&& Number of linked parameter

*css classes
*inherited part

*newly defined part
 gcCSS_ParaLink          = [DIAMP_PDM_AB_Para_Link]		&& CSS Class to format Link to a parameter

 gcCSS_Syntax            = [DIAMP_PDM_AB_Syntax]		&& CSS Class to format Syntax section
 gcCSS_Syntax_Color		 = [SColor]						&& CSS Class to format wrapping table for syntax
 gcCSS_Syntax_RetVal     = [RetVal]						&& CSS Class to format syntax column "method"
 gcCSS_Syntax_RetValSign = [RetValEq]					&& CSS Class to format syntax column "parameters"
 gcCSS_Syntax_Method     = [PEM]						&& CSS Class to format syntax table cell "method"
 gcCSS_Syntax_Para       = [Para]						&& CSS Class to format syntax table cell "parameters"
*!*	 gcCSS_Syntax_OuterTable = [_Color]					&& CSS Class to format wrapping table for syntax
*!*	 gcCSS_Syntax_MethodCol  = [RetVal]					&& CSS Class to format syntax column "method"
*!*	 gcCSS_Syntax_ParaCol    = [RetValEq]				&& CSS Class to format syntax column "parameters"
*!*	 gcCSS_Syntax_MethodCell = [PEM]					&& CSS Class to format syntax table cell "method"
*!*	 gcCSS_Syntax_ParaCell   = [Para]					&& CSS Class to format syntax table cell "parameters"

 gcCSS_Para                 = [DIAMP_PDM_AB_Params]				&& CSS Class to format section parameters description
 gcCSS_Para_Head            = [PDM_AB_Head]						&& CSS Class to format parameters head
 gcCSS_Para_List            = [DIAMP_PDM_AB_Params_List]		&& CSS Class to format parameters; definition list
 gcCSS_Para_List_dt         = [dt_]								&& CSS Class to format parameters; definition list; expression to define
 gcCSS_Para_List_dd         = [dd_]								&& CSS Class to format parameters; definition list; definition of expression
 gcCSS_Para_dd_Name         = [DIAMP_PDM_AB_Params_ParaName]	&& CSS Class to format parameters; list; name
 gcCSS_Para_dd_short        = [Params_Short]					&& CSS Class to format  parameters; list; short description
 gcCSS_Para_dd_TInfo        = [Params_Info]						&& CSS Class to format  parameters; list; table extended Information
 gcCSS_Para_dd_TIS_ColInfo  = [ColumnValue]						&& CSS Class to format  parameters; list; table extended Information; column Info
 gcCSS_Para_dd_TIS_ColDesc  = [ColumnData]						&& CSS Class to format  parameters; list; table extended Information; column description
 gcCSS_Para_dd_TIS_CellInfo = [CellValue]						&& CSS Class to format  parameters; list; table extended Information; column Info
 gcCSS_Para_dd_TIS_CellDesc = [CellData]						&& CSS Class to format  parameters; list; table extended Information; column description
 gcCSS_Para_dd_Detail       = [Params_Detail]					&& CSS Class to format  parameters; list; long description

 gcCSS_Return            = [DIAMP_PDM_AB_RetVal]		&& CSS Class to format return value
 gcCSS_Return_Head       = [PDM_AB_Head]				&& CSS Class to format return value head
 gcCSS_Return_Type       = [RetVal_Ttype]				&& CSS Class to format return value typ
 gcCSS_Return_Body       = [PDM_AB_Body]				&& CSS Class to format return value description

 PROCEDURE INIT
  PARAMETERS;
   toParent

  DODEFAULT(toParent)
  WITH THIS
   .gcSections = .gcSections+[|]+.gcParams+[|]+.gcRetVal
  ENDWITH &&THIS
 ENDPROC &&init

 PROCEDURE File_Load && Load settings
  PARAMETERS;
   tcFile,;
   tcSection
* tcFile     - PDM File
* loSettings - Object of settings
  DODEFAULT(tcFile,tcSection)

  LOCAL;
   lcSection

  WITH THIS
   .gcParams                   = .GetINIString(tcSection,[Params]                  ,.gcParams                  ,tcFile)
   .gcParamsName               = .GetINIString(tcSection,[PName]                   ,.gcParamsName              ,tcFile)
   .gcParamsType               = .GetINIString(tcSection,[PType]                   ,.gcParamsType              ,tcFile)
   .gcParamsReference          = .GetINIString(tcSection,[PByRef]                  ,.gcParamsReference         ,tcFile)
   .gcParamsDirection          = .GetINIString(tcSection,[PDir]                    ,.gcParamsDirection         ,tcFile)
   .gcParamsOptionalIn         = .GetINIString(tcSection,[PInB]                    ,.gcParamsOptionalIn        ,tcFile)
   .gcParamsOptionalOut        = .GetINIString(tcSection,[POutB]                   ,.gcParamsOptionalOut       ,tcFile)
   .gcParamsShortDesc          = .GetINIString(tcSection,[PShort]                  ,.gcParamsShortDesc         ,tcFile)
   .gcParamsLongDesc           = .GetINIString(tcSection,[PDetail]                 ,.gcParamsLongDesc          ,tcFile)
   .gcRetVal                   = .GetINIString(tcSection,[RetVal]                  ,.gcRetVal                  ,tcFile)
   .gcParaLink                 = .GetINIString(tcSection,[ParaLink]                ,.gcParaLink                ,tcFile)
   .gcParaLinkNum              = .GetINIString(tcSection,[ParaLinkNum]             ,.gcParaLinkNum             ,tcFile)

   lcSection                   = tcSection+'_CSS'
   .gcCSS_ParaLink             = .GetINIString(lcSection,[CSS_ParaLink]            ,.gcCSS_ParaLink            ,tcFile)

   .gcCSS_Syntax               = .GetINIString(lcSection,[CSS_Syntax]              ,.gcCSS_Syntax              ,tcFile)
   .gcCSS_Syntax_Color         = .GetINIString(lcSection,[CSS_Syntax_OuterTable]   ,.gcCSS_Syntax_Color        ,tcFile)
   .gcCSS_Syntax_RetVal        = .GetINIString(lcSection,[CSS_Syntax_MethodCol]    ,.gcCSS_Syntax_RetVal       ,tcFile)
   .gcCSS_Syntax_RetValSign    = .GetINIString(lcSection,[CSS_Syntax_ParaCol]      ,.gcCSS_Syntax_RetValSign   ,tcFile)
   .gcCSS_Syntax_Method        = .GetINIString(lcSection,[CSS_Syntax_MethodCell]   ,.gcCSS_Syntax_Method       ,tcFile)
   .gcCSS_Syntax_Para          = .GetINIString(lcSection,[CSS_Syntax_ParaCell]     ,.gcCSS_Syntax_Para         ,tcFile)

   .gcCSS_Para                 = .GetINIString(lcSection,[CSS_Para]                ,.gcCSS_Para                ,tcFile)
   .gcCSS_Para_Head            = .GetINIString(lcSection,[CSS_Para_Head]           ,.gcCSS_Para_Head           ,tcFile)
   .gcCSS_Para_List            = .GetINIString(lcSection,[CSS_Para_List]           ,.gcCSS_Para_List           ,tcFile)
   .gcCSS_Para_List_dt         = .GetINIString(lcSection,[CSS_Para_List_dt]        ,.gcCSS_Para_List_dt        ,tcFile)
   .gcCSS_Para_List_dd         = .GetINIString(lcSection,[CSS_Para_List_dd]        ,.gcCSS_Para_List_dd        ,tcFile)
   .gcCSS_Para_dd_Name         = .GetINIString(lcSection,[CSS_Para_dd_Name]        ,.gcCSS_Para_dd_Name        ,tcFile)
   .gcCSS_Para_dd_short        = .GetINIString(lcSection,[CSS_Para_dd_short]       ,.gcCSS_Para_dd_short       ,tcFile)
   .gcCSS_Para_dd_TInfo        = .GetINIString(lcSection,[CSS_Para_dd_TInfo]       ,.gcCSS_Para_dd_TInfo       ,tcFile)
   .gcCSS_Para_dd_TIS_ColInfo  = .GetINIString(lcSection,[CSS_Para_dd_TIS_ColInfo] ,.gcCSS_Para_dd_TIS_ColInfo ,tcFile)
   .gcCSS_Para_dd_TIS_ColDesc  = .GetINIString(lcSection,[CSS_Para_dd_TIS_ColDesc] ,.gcCSS_Para_dd_TIS_ColDesc ,tcFile)
   .gcCSS_Para_dd_TIS_CellInfo = .GetINIString(lcSection,[CSS_Para_dd_TIS_CellInfo],.gcCSS_Para_dd_TIS_CellInfo,tcFile)
   .gcCSS_Para_dd_TIS_CellDesc = .GetINIString(lcSection,[CSS_Para_dd_TIS_CellDesc],.gcCSS_Para_dd_TIS_CellDesc,tcFile)
   .gcCSS_Para_dd_Detail       = .GetINIString(lcSection,[CSS_Para_dd_Detail]      ,.gcCSS_Para_dd_Detail      ,tcFile)

   .gcCSS_Return               = .GetINIString(lcSection,[CSS_Return]              ,.gcCSS_Return              ,tcFile)
   .gcCSS_Return_Head          = .GetINIString(lcSection,[CSS_Return_Head]         ,.gcCSS_Return_Head         ,tcFile)
   .gcCSS_Return_Type          = .GetINIString(lcSection,[CSS_Return_Type]         ,.gcCSS_Return_Type         ,tcFile)
   .gcCSS_Return_Body          = .GetINIString(lcSection,[CSS_Return_Body]         ,.gcCSS_Return_Body         ,tcFile)

   .gcSections = .gcSections+[|]+.gcParams+[|]+.gcRetVal
  ENDWITH &&THIS
  RETURN _PDM_OK
 ENDPROC &&File_Load

 PROCEDURE File_Save && Save settings
  PARAMETERS;
   tcFile,;
   tcSection
* tcFile     - PDM File
* loSettings - Object of settings
  DODEFAULT(tcFile,tcSection)

  LOCAL;
   lcSection

  WITH THIS
   = WriteINIString(tcSection,[Params]                  ,ALLTRIM(.gcParams)                  ,@tcFile)
   = WriteINIString(tcSection,[PName]                   ,ALLTRIM(.gcParamsName)              ,@tcFile)
   = WriteINIString(tcSection,[PType]                   ,ALLTRIM(.gcParamsType)              ,@tcFile)
   = WriteINIString(tcSection,[PByRef]                  ,ALLTRIM(.gcParamsReference)         ,@tcFile)
   = WriteINIString(tcSection,[PDir]                    ,ALLTRIM(.gcParamsDirection)         ,@tcFile)
   = WriteINIString(tcSection,[PInB]                    ,ALLTRIM(.gcParamsOptionalIn)        ,@tcFile)
   = WriteINIString(tcSection,[POutB]                   ,ALLTRIM(.gcParamsOptionalOut)       ,@tcFile)
   = WriteINIString(tcSection,[PShort]                  ,ALLTRIM(.gcParamsShortDesc)         ,@tcFile)
   = WriteINIString(tcSection,[PDetail]                 ,ALLTRIM(.gcParamsLongDesc)          ,@tcFile)
   = WriteINIString(tcSection,[RetVal]                  ,ALLTRIM(.gcRetVal)                  ,@tcFile)
   = WriteINIString(tcSection,[ParaLink]                ,ALLTRIM(.gcParaLink)                ,@tcFile)
   = WriteINIString(tcSection,[ParaLinkNum]             ,ALLTRIM(.gcParaLinkNum)             ,@tcFile)

   lcSection = tcSection+'_CSS'
   = WriteINIString(lcSection,[CSS_ParaLink]            ,ALLTRIM(.gcCSS_ParaLink)            ,@tcFile)

   = WriteINIString(lcSection,[CSS_Syntax]              ,ALLTRIM(.gcCSS_Syntax)              ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_OuterTable]   ,ALLTRIM(.gcCSS_Syntax_Color)        ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_MethodCol]    ,ALLTRIM(.gcCSS_Syntax_RetVal)       ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_ParaCol]      ,ALLTRIM(.gcCSS_Syntax_RetValSign)   ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_MethodCell]   ,ALLTRIM(.gcCSS_Syntax_Method)       ,@tcFile)
   = WriteINIString(lcSection,[CSS_Syntax_ParaCell]     ,ALLTRIM(.gcCSS_Syntax_Para)         ,@tcFile)

   = WriteINIString(lcSection,[CSS_Para]                ,ALLTRIM(.gcCSS_Para)                ,@tcFile)
   = WriteINIString(lcSection,[CSS_Para_Head]           ,ALLTRIM(.gcCSS_Para_Head)           ,@tcFile)
   = WriteINIString(lcSection,[CSS_Para_List]           ,ALLTRIM(.gcCSS_Para_List)           ,@tcFile)
   = WriteINIString(lcSection,[CSS_Para_List_dt]        ,ALLTRIM(.gcCSS_Para_List_dt)        ,@tcFile)
   = WriteINIString(lcSection,[CSS_Para_List_dd]        ,ALLTRIM(.gcCSS_Para_List_dd)        ,@tcFile)
   = WriteINIString(lcSection,[CSS_Para_dd_Name ]       ,ALLTRIM(.gcCSS_Para_dd_Name)        ,@tcFile)
   = WriteINIString(lcSection,[CSS_Para_dd_short]       ,ALLTRIM(.gcCSS_Para_dd_short)       ,@tcFile)
   = WriteINIString(lcSection,[CSS_Para_dd_TInfo]       ,ALLTRIM(.gcCSS_Para_dd_TInfo)       ,@tcFile)
   = WriteINIString(lcSection,[CSS_Para_dd_TIS_ColInfo] ,ALLTRIM(.gcCSS_Para_dd_TIS_ColInfo) ,@tcFile)
   = WriteINIString(lcSection,[CSS_Para_dd_TIS_ColDesc] ,ALLTRIM(.gcCSS_Para_dd_TIS_ColDesc) ,@tcFile)
   = WriteINIString(lcSection,[CSS_Para_dd_TIS_CellInfo],ALLTRIM(.gcCSS_Para_dd_TIS_CellInfo),@tcFile)
   = WriteINIString(lcSection,[CSS_Para_dd_TIS_CellDesc],ALLTRIM(.gcCSS_Para_dd_TIS_CellDesc),@tcFile)
   = WriteINIString(lcSection,[CSS_Para_dd_Detail]      ,ALLTRIM(.gcCSS_Para_dd_Detail)      ,@tcFile)

   = WriteINIString(lcSection,[CSS_Return]              ,ALLTRIM(.gcCSS_Return)              ,@tcFile)
   = WriteINIString(lcSection,[CSS_Return_Head]         ,ALLTRIM(.gcCSS_Return_Head)         ,@tcFile)
   = WriteINIString(lcSection,[CSS_Return_Type]         ,ALLTRIM(.gcCSS_Return_Type)         ,@tcFile)
   = WriteINIString(lcSection,[CSS_Return_Body]         ,ALLTRIM(.gcCSS_Return_Body)         ,@tcFile)
  ENDWITH &&THIS
  RETURN _PDM_OK
 ENDPROC &&File_Save

 PROCEDURE CloneSettings && Clone values properties of settings
  PARAMETERS;
   toSrc,;
   toDst
* toSrc - Source object
* toDst - Destination object

  DODEFAULT(toSrc,toDst)

  WITH toSrc
   toDst.gcParams                   = .gcParams
   toDst.gcRetVal                   = .gcRetVal

   toDst.gcParamsName               = .gcParamsName
   toDst.gcParamsType               = .gcParamsType
   toDst.gcParamsReference          = .gcParamsReference
   toDst.gcParamsDirection          = .gcParamsDirection
   toDst.gcParamsOptionalIn         = .gcParamsOptionalIn
   toDst.gcParamsOptionalOut        = .gcParamsOptionalOut
   toDst.gcParamsShortDesc          = .gcParamsShortDesc
   toDst.gcParamsLongDesc           = .gcParamsLongDesc

   toDst.gcLink                     = .gcLink
   toDst.gcLinkClassLoc             = .gcLinkClassLoc
   toDst.gcLinkCLass                = .gcLinkCLass
   toDst.gcLinkPEMName              = .gcLinkPEMName

   toDst.gcAppliesTo                = .gcAppliesTo
   toDst.gcAppliesToSwitch          = .gcAppliesToSwitch

   toDst.gcParaLink                 = .gcParaLink
   toDst.gcParaLinkNum              = .gcParaLinkNum

   toDst.gcCSS_ParaLink             = .gcCSS_ParaLink

   toDst.gcCSS_Syntax               = .gcCSS_Syntax
   toDst.gcCSS_Syntax_Color         = .gcCSS_Syntax_Color
   toDst.gcCSS_Syntax_RetVal        = .gcCSS_Syntax_RetVal
   toDst.gcCSS_Syntax_RetValSign    = .gcCSS_Syntax_RetValSign
   toDst.gcCSS_Syntax_Method        = .gcCSS_Syntax_Method
   toDst.gcCSS_Syntax_Para          = .gcCSS_Syntax_Para

   toDst.gcCSS_Para                 = .gcCSS_Para
   toDst.gcCSS_Para_Head            = .gcCSS_Para_Head
   toDst.gcCSS_Para_List            = .gcCSS_Para_List
   toDst.gcCSS_Para_List_dt         = .gcCSS_Para_List_dt
   toDst.gcCSS_Para_List_dd         = .gcCSS_Para_List_dd
   toDst.gcCSS_Para_dd_Name         = .gcCSS_Para_dd_Name
   toDst.gcCSS_Para_dd_short        = .gcCSS_Para_dd_short
   toDst.gcCSS_Para_dd_TInfo        = .gcCSS_Para_dd_TInfo
   toDst.gcCSS_Para_dd_TIS_ColInfo  = .gcCSS_Para_dd_TIS_ColInfo
   toDst.gcCSS_Para_dd_TIS_ColDesc  = .gcCSS_Para_dd_TIS_ColDesc
   toDst.gcCSS_Para_dd_TIS_CellInfo = .gcCSS_Para_dd_TIS_CellInfo
   toDst.gcCSS_Para_dd_TIS_CellDesc = .gcCSS_Para_dd_TIS_CellDesc
   toDst.gcCSS_Para_dd_Detail       = .gcCSS_Para_dd_Detail

   toDst.gcCSS_Return               = .gcCSS_Return
   toDst.gcCSS_Return_Head          = .gcCSS_Return_Head
   toDst.gcCSS_Return_Type          = .gcCSS_Return_Type
   toDst.gcCSS_Return_Body          = .gcCSS_Return_Body
  ENDWITH &&toSrc
 ENDPROC &&CloneSettings
ENDDEFINE &&_DIAMP_PDM_AB_par
