#INCLUDE "diac_pdm.h"

*************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_diac_pdm",lcCollate)


***********************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_diac_pdm_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_diac_pdm_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)


*******************************************************
DEFINE CLASS _diac_pdm AS _pdm_PlugIn && 
   Name="_diac_pdm"

   ID=2000         && ID of Plug-in
   Type="DIAC" && Typ of plug-in (group)
   Alias=""     && Alias for table with meta data

*!*	   ShareMode=_PDM_SM_Share
*!*	   ShareGroup=5

   ShareMode=_PDM_SM_None
   ShareGroup=0


   Setting=.NULL.
   Par=.NULL.


   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
      INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "PDM - Detail description of class/object")
      SELE (This.ALTab)
      INDEX ON XX000 TAG I01
   ENDPROC

   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,lii,lcHTML,;
            lcMethod,liParams,liSeeAlso,lcPom,;
            lcParams,lcFile,lcClass,loObj,llDal,loPDM

      LOCAL ARRAY laSection(8),laData(1),laOut(1)
      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)

      This.Setting=loSetting
      This.Par=loPar

      lcHTML=[<table>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(1)+[<tbody>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td>PlugIn Class:</td><td>]+This.Name+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td>PlugIn ID:</td><td>]+LTRIM(STR(This.ID,11))+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td>PlugIn Group:</td><td>]+This.Type+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td colspan="2"><hr /></td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td>Class:</td><td>]+loPar.cParent+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td>Source file:</td><td>]+loPar.File+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td>Current Group:</td><td>]+loPar.Type+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td>File Group:</td><td>]+LTRIM(STR(loPar.FileGroup,11))+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td colspan="2"><hr /></td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td>Units:</td><td>]+loPar.Ram.Reserved6+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td>Comment:</td><td>]+loPar.Ram.Reserved7+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(2)+[<tr><td>h File:</td><td>]+loPar.Ram.Reserved8+[</td></tr>]+m.loPDM.aSpace(21)+;
             m.loPDM.aSpace(1)+[</tbody>]+m.loPDM.aSpace(21)+;
             [</table>]+m.loPDM.aSpace(21)


      STORE .NULL. TO This.Setting,This.Par

      RETURN lcHTML
   ENDPROC

   PROCEDURE GetScript()
      RETURN []
   ENDPROC


   PROCEDURE GetSetting() &&  Return settings object
      RETURN CREATEOBJECT("_diac_pdm_par")
   ENDPROC


   PROCEDURE Open(lcFile,loSettings) && Load settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.xhtmlS=GetINIString(lcSection,"XHTMLS",loSettings.xhtmlS,254,@lcFile)
      loSettings.xhtmlE=GetINIString(lcSection,"XHTMLE",loSettings.xhtmlE,254,@lcFile)
      loSettings.SeeS=GetINIString(lcSection,"SEES",loSettings.SeeS,254,@lcFile)
      loSettings.SeeE=GetINIString(lcSection,"SEEE",loSettings.SeeE,254,@lcFile)
      loSettings.CodeS=GetINIString(lcSection,"CODES",loSettings.CodeS,254,@lcFile)
      loSettings.CodeE=GetINIString(lcSection,"CODEE",loSettings.CodeE,254,@lcFile)
      loSettings.ExprS=GetINIString(lcSection,"EXPRS",loSettings.ExprS,254,@lcFile)
      loSettings.ExprE=GetINIString(lcSection,"EXPRE",loSettings.ExprE,254,@lcFile)

      loSettings.noteS=GetINIString(lcSection,"NOTES",loSettings.noteS,254,@lcFile)
      loSettings.noteE=GetINIString(lcSection,"NOTEE",loSettings.noteE,254,@lcFile)
      loSettings.stopS=GetINIString(lcSection,"STOPS",loSettings.stopS,254,@lcFile)
      loSettings.stopE=GetINIString(lcSection,"STOPE",loSettings.stopE,254,@lcFile)
      loSettings.questS=GetINIString(lcSection,"QUESTS",loSettings.questS,254,@lcFile)
      loSettings.questE=GetINIString(lcSection,"QUESTE",loSettings.questE,254,@lcFile)
      loSettings.exclaS=GetINIString(lcSection,"EXCLAS",loSettings.exclaS,254,@lcFile)
      loSettings.exclaE=GetINIString(lcSection,"EXCLAE",loSettings.exclaE,254,@lcFile)
      loSettings.infoS=GetINIString(lcSection,"INFOS",loSettings.infoS,254,@lcFile)
      loSettings.infoE=GetINIString(lcSection,"INFOE",loSettings.infoE,254,@lcFile)

      loSettings.Source=GetINIString(lcSection,"Source",loSettings.Source,254,@lcFile)
      loSettings.CSS=GetINIString(lcSection,"CSS",loSettings.CSS,254,@lcFile)
      loSettings.JS=GetINIString(lcSection,"JS",loSettings.JS,254,@lcFile)

      RETURN _PDM_OK
   ENDPROC

   PROCEDURE Save(lcFile,loSettings) && Save settings
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"XHTMLS",ALLT(loSettings.xhtmlS),@lcFile)
      =WriteINIString(lcSection,"XHTMLE",ALLT(loSettings.xhtmlE),@lcFile)
      =WriteINIString(lcSection,"SEES",ALLT(loSettings.SeeS),@lcFile)
      =WriteINIString(lcSection,"SEEE",ALLT(loSettings.SeeE),@lcFile)
      =WriteINIString(lcSection,"BYREF",ALLT(loSettings.ByRef),@lcFile)
      =WriteINIString(lcSection,"CODES",ALLT(loSettings.CodeS),@lcFile)
      =WriteINIString(lcSection,"CODEE",ALLT(loSettings.CodeE),@lcFile)
      =WriteINIString(lcSection,"EXPRS",ALLT(loSettings.ExprS),@lcFile)
      =WriteINIString(lcSection,"EXPRE",ALLT(loSettings.ExprE),@lcFile)

      =WriteINIString(lcSection,"NOTES",ALLT(loSettings.noteS),@lcFile)
      =WriteINIString(lcSection,"NOTEE",ALLT(loSettings.noteE),@lcFile)
      =WriteINIString(lcSection,"STOPS",ALLT(loSettings.stopS),@lcFile)
      =WriteINIString(lcSection,"STOPE",ALLT(loSettings.stopE),@lcFile)
      =WriteINIString(lcSection,"QUESTS",ALLT(loSettings.questS),@lcFile)
      =WriteINIString(lcSection,"QUESTE",ALLT(loSettings.questE),@lcFile)
      =WriteINIString(lcSection,"EXCLAS",ALLT(loSettings.exclaS),@lcFile)
      =WriteINIString(lcSection,"EXCLAE",ALLT(loSettings.exclaE),@lcFile)
      =WriteINIString(lcSection,"INFOS",ALLT(loSettings.infoS),@lcFile)
      =WriteINIString(lcSection,"INFOE",ALLT(loSettings.infoE),@lcFile)

      =WriteINIString(lcSection,"Source",ALLT(loSettings.Source),@lcFile)
      =WriteINIString(lcSection,"CSS",ALLT(loSettings.CSS),@lcFile)
      =WriteINIString(lcSection,"JS",ALLT(loSettings.JS),@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst) && Clone values properties of settings
      * loSrc - Source object
      * loDst - Destination object

      loDst.xhtmlS=loSrc.xhtmlS
      loDst.xhtmlE=loSrc.xhtmlE
      loDst.SeeS=loSrc.SeeS
      loDst.SeeE=loSrc.SeeE
      loDst.ByRef=loSrc.ByRef
      loDst.CodeS=loSrc.CodeS
      loDst.CodeE=loSrc.CodeE
      loDst.ExprS=loSrc.ExprS
      loDst.ExprE=loSrc.ExprE

      loDst.noteS=loSrc.noteS
      loDst.noteE=loSrc.noteE
      loDst.stopS=loSrc.stopS
      loDst.stopE=loSrc.stopE
      loDst.questS=loSrc.questS
      loDst.questE=loSrc.questE
      loDst.exclaS=loSrc.exclaS
      loDst.exclaE=loSrc.exclaE
      loDst.infoS=loSrc.infoS
      loDst.infoE=loSrc.infoE

      loDst.Source=loSrc.Source
      loDst.CSS=loSrc.CSS
      loDst.JS=loSrc.JS
   ENDPROC

   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL loPDMs,lcLang,lcPath,lcFile,llEn
      loPDMs=EVAL(This.PDMs)
      lcLang=loPDMs.HTMLCLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Open table with HTML's string
      IF !USED(This.AHTML)
         CREATE CURSOR (This.AHTML) (XX000 I, XX001 M)
         INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Remarks, "Remarks")
         INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Example, "Example")
         INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_SeeAlso, "See Also")
         INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Appliesto, "Applies to")
         SELE (This.AHTML)
         INDEX ON XX000 TAG I01
      ENDIF

      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources() && Close other source
*!*	      IF USED(This.Alias)
*!*	         USE IN (This.Alias)
*!*	      ENDIF
      RETURN .T.
   ENDPROC

ENDDEFINE

****************************************************************
DEFINE CLASS _diac_pdm_par AS _pdm_PlugIn_Parameter && Settings for plug-in
   Name="_diac_pdm_par"
   OK=.F.
   DIME aCSS(1),aJS(1)
 
   xhtmlS="<xhtml>"
   xhtmlE="</xhtml>"
   SeeS="<see>"
   SeeE="</see>"
   ByRef="ByRef"
   CodeS="<code>"
   CodeE="</code>"
   ExprS="<expr>"
   ExprE="</expr>"


   noteS="<note>"
   noteE="</note>"
   stopS="<noteS>"
   stopE="</noteS>"
   questS="<noteQ>"
   questE="</noteQ>"
   exclaS="<noteE>"
   exclaE="</noteE>"
   infoS="<noteI>"
   infoE="</noteI>"

   Source="" && Table with meta code for methods/procedures
   CSS="diac_pdm.css" && Relative to diamp_pdm.fxp
   JS="diac_pdm.js" && Relative to diamp_pdm.fxp

   _CSS="" && Relative to ....
   _JS="" && 

ENDDEFINE

