#INCLUDE "efrx_frx2word.h"
#INCLUDE "../prgs/main.h"

*******************************************************************************
PROCEDURE PDM_GetInterface(loInst,lcCollate) && Return instace of Plug-In
loInst=CREATEOBJECT("_EFRX_FRX2word",lcCollate)



*********************************************************************************
PROCEDURE PDM_GetGUI(loInterface,loPI,loSettings,lcLang) && Show form for settings
*@loInterface - Interface of plug-in
*@loPI        - Plug-in
*@loSettings  - Plug-in settings
* lcLang      - Language

LOCAL lcFile,lcClass
lcFile=ExtractShortFileFromFile(SUBST(SYS(16),AT(" ",SYS(16),2)+1))
lcClass="_EFRX_FRX2word_frm_"+lcLang

* Load localize VCX library
IF !lcLang=="en" AND ATC(lcFile+"_"+lcLang+".VCX",SET("CLASSLIB"))=0
   lcClass="_EFRX_FRX2word_frm_en"
ENDIF
loInterface=CREATEOBJECT(lcClass,@loPI,@loSettings)

************************************************************************
DEFINE CLASS _EFRX_FRX2word AS _pdm_PlugIn && 
   Name="_EFRX_FRX2word"

   ID=104        && ID of Plug-in
   Type="EFRX" && 



   PROCEDURE GetCaption() && Return Caption of Plug-in
      RETURN This.GetString(PI_Caption)
   ENDPROC

   PROCEDURE GetDescription() && Return Description of Plug-in
      RETURN This.GetString(PI_Description)
   ENDPROC

   PROCEDURE Initialize() && Additive initialize
      * Load shared fxp modul for parsing texts (xhtml/code/see)
      LOCAL luCatch,lcPath,lcFile,lcClass,loPDMs,lcGUILang,llEn
      loPDMs=EVAL(This.PDMs)
      lcGUILang=loPDMs.GUICLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Load basic VCX library for GUI
      IF ATC(lcFile+".VCX",SET("CLASSLIB"))=0
         luCatch=loPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+".vcx") ADDITIVE
         =loPDMs.SetCatch(luCatch) && Vra zachycen chyby
         IF loPDMs.nErr#0
            RETURN .F.
         ENDIF
      ENDIF

      * Load localize VCX library
      IF !lcGUILang=="en" AND ATC(lcFile+"_"+lcGUILang+".VCX",SET("CLASSLIB"))=0
         luCatch=poPDMs.SetCatch(.T.) && Nastav zachycen chyby
         SET CLASSLIB TO (lcPath+lcFile+"\"+lcFile+"_"+lcGUILang+".vcx") ADDITIVE
         =poPDMs.SetCatch(luCatch) && Vra zachycen chyby
      ENDIF

      * Open table with localized strind for GUI
      llEn=.T.
      IF !lcGUILang=="en" AND ;
         loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\"+lcGUILang+".dbf",This.ALTAB,"NOUPDATE")=0
         SELE (This.ALTab)
         SET ORDER TO "I01"
         llEn=.F.
      ENDIF

      IF llEn
         CREATE CURSOR (This.ALTab) (XX000 I, XX001 M)
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Caption, "FRX2Word")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_valGetCSS, "CSS File")
         INSERT INTO (This.ALTab) (XX000, XX001) VALUE (PI_Description, [Plug-in pro zpracovn metadat ve sloupci COMMENT reportu/ttku pro konvertor FRX2Word.])

         SELE (This.ALTab)
         INDEX ON XX000 TAG I01
      ENDIF
   ENDPROC


   PROCEDURE Render(loPar,loSetting)
      * loPar     - Object of parameters
      * loSetting - Settings's object of plug-in
      LOCAL loPDMs,loPDM,lii,liCount,lcHTML,lix,lcTooltip,;
            llSingle,lcComment,lcRow,liz,;
            lcURHREF,llExtract,liy,lix,lcAHREF,lcFile,lcPom,lcPom2


      loPDMs=EVAL(This.PDMs)
      loPDM=EVAL(This.PDM)
      
      STORE "" TO lcHTML,lcTooltip,lcURHREF

      lcComment=loPar.Ram.COMMENT
      lcFile=UPPER(loPar.File)

      * Hyperlink
      ***********
      * link= http://www.universalthread.com; Web site about vfp and other sw

      liCount=ALINES(laRows,lcComment)
      lcComment=""
      FOR lii=1 TO liCount
          lcRow=LTRIM(laRows(lii))

          liz=AT_NonSpace(@lcRow,1) && najdi prvn znak
          liz=IIF(liz=0,1,liz)

          llExtract=.F.
          IF UPPER(SUBST(lcRow,liz,4))=="LINK"
             IF LEN(lcURHREF)=0
                liy=AT_Ex(@lcRow,"=",liz+4) && Najdi =

                IF liy>0
                   lix=AT(';',lcRow)

                   IF lix>0
                      lcTooltip=SUBS(m.lcRow,lix+1)
                      lcRow=LEFT(m.lcRow,lix-1)
                   ENDIF

                   lix=AT_Ex(@lcRow,':',liy+2)
                   IF lix>0
                      lcAHREF=ALLT(UPPER(SUBSTR(lcRow,liy+1,lix-liy)))
                      IF lcAHREF=="HTTP:" OR lcAHREF=="HTTPS:" OR lcAHREF=="FILE:" OR;
                         lcAHREF=="FTP:" OR lcAHREF=="GOPHER:" OR;
                         lcAHREF=="MAILTO:" OR lcAHREF=="NEWS:" OR lcAHREF=="TELNET:" OR;
                         lcAHREF=="WAIS:"
                         liz=AT_Ex(@lcRow,"'",lix+1) && Najdi ']
                         liz=IIF(liz=0,AT_Ex(@lcRow,"]",lix+1),liz)
                         lcURHREF=[<a href="]+ALLT(SUBST(lcRow,liy+1))+[" title="]+lcTooltip+[">]+ALLT(SUBST(lcRow,liy+1))+[</a>]
                      ENDIF
                   ELSE
                      lcURHREF=ALLT(SUBST(lcRow,liy+1))
                   ENDIF
                   
                   llExtract=.T.
                ENDIF
             ELSE
                llExtract=.T.
             ENDIF
          ENDIF

          IF !llExtract
             lcComment=lcComment+lcRow+CRLF
          ENDIF
      NEXT

      IF LEN(lcURHREF)>0 
         lcHTML=lcHTML+;
                m.loPDM.aSpace(1)+[<table><tbody>]+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcURHREF)>0
         lcHTML=lcHTML+;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_frx2word_td_bold">]+This.GetHTMLString(PI_HTML_Hyperlink)+;
                                  [</td><td>]+lcURHREF+"</td></tr>"+m.loPDM.aSpace(21)+;
                IIF(LEN(lcTooltip)=0,"",;
                m.loPDM.aSpace(2)+[<tr><td class="efrx_frx2word_td_bold">]+This.GetHTMLString(PI_HTML_Tooltip)+;
                                  [</td><td>]+lcTooltip+"</td></tr>"+m.loPDM.aSpace(21))
      ENDIF

      IF LEN(lcURHREF)>0 
         lcHTML=lcHTML+;
                m.loPDM.aSpace(1)+[</tbody></table>]+m.loPDM.aSpace(21)
      ENDIF

      IF LEN(lcHTML)>0
         lcHTML=m.loPDM.aSpace(1)+"<hr>"+m.loPDM.aSpace(21)+lcHTML
      ENDIF

      loPar.Ram.COMMENT=lcComment

      RETURN lcHTML
   ENDPROC

   PROCEDURE GetSetting()
      RETURN CREATEOBJECT("_EFRX_FRX2word_par")
   ENDPROC

   * Nate nastaven
   PROCEDURE Open(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      loSettings.CSS=GetINIString(lcSection,"CSS",loSettings.CSS,254,@lcFile)
      loSettings.JS=GetINIString(lcSection,"JS",loSettings.JS,254,@lcFile)

      RETURN _PDM_OK
   ENDPROC

   * Ulo nastaven
   PROCEDURE Save(lcFile,loSettings)
      * lcFile     - PDM File
      * loSettings - Object of settings
      LOCAL lcSection
      lcSection="PI_"+LTRIM(STR(This.ID,11))

      =WriteINIString(lcSection,"CSS",ALLT(loSettings.CSS),@lcFile)
      =WriteINIString(lcSection,"JS",ALLT(loSettings.JS),@lcFile)
      RETURN _PDM_OK
   ENDPROC


   PROCEDURE Clone(loSrc,loDst)
      * loSrc - Source object
      * loDst - Destination object
      loDst.CSS=loSrc.CSS
      loDst.JS=loSrc.JS
   ENDPROC

   PROCEDURE OpenSources(loSetting) && Open other source
      * loSetting - Object of settings
      LOCAL loPDMs,lcLang,lcPath,lcFile,llEn
      loPDMs=EVAL(This.PDMs)
      lcLang=loPDMs.HTMLCLang

      lcFile=ExtractShortFileFromFile(This.MainFile)
      lcPath=This.MainPath

      * Open table with HTML's string
      IF !USED(This.AHTML)
         llEn=.T.
         IF !lcLang=="en" AND ;
            loPDMs.OpenTable(This.DataSessionID,lcPath+lcFile+"\HTML_"+lcLang+".dbf",This.AHTML,"NOUPDATE")=0
            llEn=.F.
            SELE (This.AHTML)
            SET ORDER TO "I01"
         ENDIF
         IF llEn
            CREATE CURSOR (This.AHTML) (XX000 I, XX001 M)
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Hyperlink, "Hyperlink:")
            INSERT INTO (This.AHTML) (XX000, XX001) VALUE (PI_HTML_Tooltip, "Tooltip:")
            SELE (This.AHTML)
            INDEX ON XX000 TAG I01
         ENDIF
      ENDIF
      RETURN .T.
   ENDPROC

   PROCEDURE CloseSources()
      RETURN .T.
   ENDPROC

ENDDEFINE

*********************************************************
DEFINE CLASS _EFRX_FRX2word_par AS _pdm_PlugIn_Parameter
   Name="_EFRX_FRX2word_par"
   DIME aCSS(1),aJS(1)
   OK=.F.
 
   CSS="efrx_frx2word.css" && Relative to efrx_xfrx.fxp
   JS="" && 

   _CSS="" && Relative to ....
   _JS="" && 

ENDDEFINE


